procedure regpol(nmax,m:integer; x,y:sir;
                 var coef:sir; var abst:real; var grad:integer);


var
  i,j,l,n1,n2,k:integer;
  yc,p:real;
  sumx,sumxy:sir;
  b,d:sir;
  a,w:matrice;
  fis:text;

begin
  assign(fis,'fregpol.dat');
  rewrite(fis);

  n1:=nmax+1;
  n2:=2*nmax+1;

  { calcul sume in x si y }

  sumx[1]:=m;
  for l:=2 to n2 do
    begin
      sumx[l]:=0;
      for i:=1 to m do
        sumx[l]:=sumx[l]+powxn(x[i],l-1);
    end;
  sumxy[1]:=0;
  for i:=1 to m do
    sumxy[1]:=sumxy[1]+y[i];
  for l:=2 to n1 do
    begin
		  sumxy[l]:=0;
      for i:=1 to m do
        sumxy[l]:=sumxy[l]+y[i]*powxn(x[i],l-1);
    end;


  for k:=1 to nmax do
    begin

    { generarea matricii sistemului }

      for i:=1 to k+1 do
        begin
          l:=i;
          for j:=1 to k+1 do
            begin
              a[i,j]:=sumx[l];
              l:=l+1;
            end;
        end;
      for i:=1 to k+1 do
        b[i]:=sumxy[i];

    { rezolvarea sistemului de ecuatii }

      gauss1(a,b,k+1,coef,0);

    { estimarea parametrilor statistici }

      d[k]:=0;
      for i:=1 to m do
        begin
          yc:=coef[1];
          for j:=2 to k+1 do
            yc:=yc+coef[j]*powxn(x[i],j-1);
          d[k]:=d[k]+(y[i]-yc)*(y[i]-yc);
        end;

      { protectia rezultatelor }

        for i:=1 to k+1 do
          w[k,i]:=coef[i];

       { imprimarea rezultatelor partiale}

    writeln(fis,'*************************************************************');
    writeln(fis);
    writeln(fis,'Gradul polinomului de regresie = ',k);
    writeln(fis);
    writeln(fis,'Abaterea standard = ',sqrt(d[k]/(m-1)));
    writeln(fis);
    writeln(fis,'*************************************************************');
    writeln(fis);
    writeln(fis,'Coeficientii polinomului de regresie');
    writeln(fis);
    for i:=1 to k+1 do
        writeln(fis,'a',i-1,' = ',w[k,i]);
    writeln(fis);
    writeln(fis,'*************************************************************');
    writeln(fis,'i        x                 y                ycalc       abatere %');
      for i:=1 to m do
        begin
          yc:=coef[1];
          for j:=2 to n1 do
            yc:=yc+coef[j]*powxn(x[i],j-1);
          p:=(y[i]-yc)/y[i]*100;
          writeln(fis,i,'  ',x[i]:14,'    ',y[i]:14,'    ',yc:14,'    ',p:5:1);
        end;
    writeln(fis,'*************************************************************');
  end;

    { determinarea celei mai bune ecuatii de regresie }

    grad:=1;
    for i:=2 to nmax do
      if d[grad]>d[i] then grad:=i;

    { imprimarea rezultatelor }

    writeln(fis,'*************************************************************');
    writeln(fis);
    writeln(fis,'Gradul optim al polinomului de regresie = ',grad);
    writeln(fis);
    writeln(fis,'Abaterea standard = ',sqrt(d[grad]/(m-1)));
    writeln(fis);
    writeln(fis,'*************************************************************');
    writeln(fis);
    writeln(fis,'Coeficientii polinomului de regresie');
    writeln(fis);
    for i:=1 to grad+1 do
        writeln(fis,'a',i-1,' = ',w[grad,i]);
    writeln(fis);
    writeln(fis,'*************************************************************');
    writeln(fis,'i        x                 y                ycalc       abatere %');
      for i:=1 to m do
        begin
          yc:=coef[1];
          for j:=2 to n1 do
            yc:=yc+coef[j]*powxn(x[i],j-1);
          p:=(y[i]-yc)/y[i]*100;
          writeln(fis,i,'  ',x[i]:14,'    ',y[i]:14,'    ',yc:14,'    ',p:5:1);
        end;
    writeln(fis,'*************************************************************');
    abst:=sqrt(d[grad]/(m-1));
    close(fis);
end;  {regpol}