Procedure SNewton(n:integer; x0:sir; epsi:real; nmax:integer;
                  func:sistem_functii; jacobian:matrice_jacobian; nume_fis:string;
                  var x:sir; var kod:integer);

{ semnificatia variabilelor

      n : numarul de ecuatii/necunoscute
      x0 : sirul solutie initiala
      epsi : precizia
      nmax : numarul maxim de iteratii

      x : sirul solutie
      kod : codul de eroare (kod = 0 : succes!)
}

{Modificat 2003 CP}

var i,iter,kodgauss,kods:integer;
    a:matrice;
    b,deltax:sir;
    x1,x2,f1,f2:sir;
    fis:text;

label 1,2;

begin
      assign(fis,nume_fis);
      rewrite(fis);
      kod:=0;
      iter:=0;

      writeln(fis,'algoritmul newton-raphson * sisteme de ecuatii neliniare');
      for i:=1 to n do
          x1[i]:=x0[i];
  {calculul functiei}
      func(n,x1,f1);

      writeln(fis,'iteratia ',iter);
      for i:=1 to n do
          writeln(fis,'x[',i,']= ',x1[i],'    f[',i,']= ',f1[i]);


  {calculul jacobianului }
1:    jacobian(n,x1,a);
      for i:=1 to n do
           b[i]:=-f1[i];
   {rezolvarea sistemului de ecuatii liniare in deltax }
      gauss2(n,a,b,'f_gauss.dat',deltax,kodgauss);

      if kodgauss=2 then
         begin
            writeln(fis,'eroare in gauss2 - abandon snewton');
            goto 2;
         end;

      {calcul coordonata x2}
      for i:=1 to n do
        x2[i]:=x1[i]+deltax[i];

      {calculul functiei in punctul x2 }
      func(n,x2,f2);
      iter:=iter+1;


      writeln(fis,'iteratia ',iter);
      for i:=1 to n do
         writeln(fis,'x[',i,']= ',x2[i],'    f[',i,']= ',f2[i]);

      {test numar iteratii}
      if iter>nmax then
           begin
              writeln(fis, 'depasirea numarului maxim de iteratii');
              kod:=1;
              goto 2;
           end;

      {test stop}
      kods:=0;
      for i:=1 to n do
        if abs(f2[i])>epsi then kods:=1;
      if kods=1 then
           begin
               for i:=1 to n do
                  begin
                    x1[i]:=x2[i];
                    f1[i]:=f2[i];
                  end;
               goto 1;
           end;

      writeln(fis,'solutia sistemului de ecuatii');
      for i:=1 to n do
         writeln(fis,'x[',i,']= ',x2[i],'    f[',i,']= ',f2[i]);

2:
    close(fis);
end; {snewton}
